function TFR = Caf2tfr(AF,kernel)
//From ambiguity plane to time frequency plane
// Calling Sequence
// TFR = Caf2tfr(AF,kernel)
// Parameters
// AF     :    Ambiguity function of the signal
// kernel : kernel of the TFR
// Description
// Computes the Cohen's group Time Frequency Representation (TFR)
// of a signal given its ambiguity function and the kernel
// of the TFR.
// Warning : AF and kernel are matrices of the same size and quadratic!
//
// Examples
//   //Wigner TFR of a tone embedded in noise
//   AF = Cambifunb(hilbert(sin(2*%pi*0.25*(1:128))+0.5*rand(1,128,'normal')),-63:64,128);
//   ker = Ctfrker(128,128,'WV');
//   Wigner_TFR = Caf2tfr(AF,ker);
//   grayplot(1:128,linspace(0,0.5,128),Wigner_TFR'); 
//
// See also
// Cambifunb
// Ctfrker
// Authors
// H. Nahrstaedt - Sep 2010
// Emmanuel Roy - 2000
// Manuel Davy - 2000