function [NAF,TAU,XI] = Cambifunb(X,TAU,N);
// Ambiguity function
// Calling Sequence
// [NAF,TAU,XI] = Cambifunb(X);
// [NAF,TAU,XI] = Cambifunb(X,TAU);
// [NAF,TAU,XI] = Cambifunb(X,TAU,N);
// Parameters
// X           : Signal for which the AF should be computed
// TAU         : Vector of lag values     (default : -Nx/2:Nx/2).
// N           : Number of frequency bins (default : length(X)).
// NAF         : doppler-lag representation, with the doppler bins stored       in the rows and the time-lags stored in the columns.
// XI          : vector of doppler values.
// Desciption
// Computes the narrow-band ambiguity function
// Note: The cross ambiguity function is not implemented yet
//
// Examples
//  [AF,TAU,XI]=Cambifunb(hilbert(sin(2*%pi*0.25*(1:128)))+0.5*rand(1,128,'normal'),-63:64,128);
//  grayplot(XI,TAU,abs(AF)')
//  xlabel('Time lag'); ylabel('Frequency lag')
// Authors
// H. Nahrstaedt - Sep 2010
// Emmanuel Roy - 2000
// Manuel Davy - 2000