// ANSI C Time-Frequency toolbox.
// Version 0.1   15-nov-2000
//
//
// Time-Frequency representations     
//   Ctfrbj         - Born-Jordan time-frequency distribution.
//   Ctfrbud        - Butterworth time-frequency distribution.
//   Ctfrcw         - Choi-Williams time-frequency distribution.
//   Ctfrgrd        - Generalized rectangular time-frequency distribution.
//   Ctfrmh         - Margenau-Hill time-frequency distribution.
//   Ctfrmhs        - Margenau-Hill-Spectrogram time-frequency distribution.
//   Ctfrmmce       - Minimum mean cross-entropy combination of spectrograms.
//   Ctfrpage       - Page time-frequency distribution.
//   Ctfrpmh        - Pseudo Margenau-Hill time-frequency distribution.
//   Ctfrppage      - Pseudo Page time-frequency distribution.
//   Ctfrpwv        - Pseudo Wigner-Ville time-frequency distribution.
//   Ctfrri         - Rihaczek time-frequency distribution.
//   Ctfrridb       - Reduced Interference Distribution with Bessel kernel.
//   Ctfrridbn      - Reduced Interference Distribution with binomial kernel.
//   Ctfrridh       - Reduced Interference Distribution with Hanning kernel.
//   Ctfrridt       - Reduced Interference Distribution with Triangular kernel.
//   Ctfrrsp        - Reassigned Spectrogram
//   Ctfrsp         - Spectrogram Time Frequency distribution
//   Ctfrspwv       - Smoothed Pseudo Wigner-Ville time-frequency distribution.
//   Ctfrstft       - Short time Fourier transform
//   Ctfrwv         - Wigner-Ville time-frequency distribution.
//   Ctfrzam        - Zao-Atlas-Marks time-frequency distribution.
//
// Ambiguity plane function
//   Cambifunb      - Ambiguity function
//   Ctfrker        - Time frequency representation kernel 
//   Caf2tfr        - From ambiguity plane to time frequency plane
//
// Miscellanaeous functions
//   Chtl           - Hough transform for detection of lines in images.
//   Ctfrdist       - Time frequency distance measures
//   Ctfrreas       - Time Frequency Representation reassignment
//   Cwindow        - Window generation.
//
//
//   Copyright (c) 2000 by Manuel DAVY, Emmanuel ROY 


