function [TFR,T,F]=Ctfrgrd(X,T,N,G,H,RS,MOVERN)
// Generalized rectangular time-frequency distribution.
// Calling Sequence
// [TFR,T,F]=Ctfrgrd(X)
//[TFR,T,F]=Ctfrgrd(X,T)
// [TFR,T,F]=Ctfrgrd(X,T,N)
// [TFR,T,F]=Ctfrgrd(X,T,N,G)
// [TFR,T,F]=Ctfrgrd(X,T,N,G,H)
// [TFR,T,F]=Ctfrgrd(X,T,N,G,H,RS)
// [TFR,T,F]=Ctfrgrd(X,T,N,G,H,RS,MOVERN)
// Parameters
// X      : Analyzedd signal
// T      : time instant(s)         (default : 1:length(X)).
// N      : number of frequency bins (default : length(X))
// G      : time smoothing window    (default : Hamming(N/10)). 
// H      : frequency smoothing window (default : Hamming(N/4)). 
// RS     : kernel width            (default : 1).
// MOVERN : dissymmetry ratio       (default : 1).
//
// TFR    : time-frequency representation
// F      : vector of normalized frequencies.
// Description
//  computes the Generalized Rectangular distribution of a signal X. 
// Examples
//   x = hilbert(sin(2*%pi*0.25*(1:128))+0.5*rand(1,128,'normal'));  
//   g=Cwindow(9,'hamming'); h=Cwindow(27,'hamming'); 
//   t=1:128; [tfr,T,F]=Ctfrgrd(x,t,128,g,h,36,1/5);
//        grayplot(T,F,tfr'); xlabel('time'); ylabel('frequency')
// Authors
// H. Nahrstaedt - Sep 2010
// Emmanuel Roy - 2000
// Manuel Davy - 2000