function [TFR,T,F]=Ctfrmmce(X,H,T,N)
// Minimum mean cross-entropy combination of spectrograms.
// Calling Sequence
// [TFR,T,F]=Ctfrmmce(X)
// [TFR,T,F]=Ctfrmmce(X,H)
// [TFR,T,F]=Ctfrmmce(X,H,T)
// [TFR,T,F]=Ctfrmmce(X,H,T,N)
// Parameters
// X     : Analyzed signal.
// H     : frequency smoothing windows, stored in a matrix.   Each row is a window
// T     : time instant(s)          (default : 1:length(X)).
// N     : number of frequency bins (default : length(X))
//
// TFR   : time-frequency representation.
// F     : vector of normalized frequencies.
// Description
// computes  the minimum mean cross-entropy combination of
// spectrograms using aswindows the columns of the matrix H
// Examples
//   x = hilbert(sin(2*%pi*0.25*(1:128))+0.5*rand(1,128,'normal'));
//   h(10+(-5:5),1)=Cwindow(11,'gauss'); h(10+(-7:7),2)=Cwindow(15,'gauss');  
//   h(10+(-9:9),3)=Cwindow(19,'gauss'); [tfr,T,F]=Ctfrmmce(x,h);
//   grayplot(T,F,tfr');  xlabel('time'); ylabel('frequency')
// See also
// Ctfrsp
// Authors
// H. Nahrstaedt - Sep 2010
// Emmanuel Roy - 2000
// Manuel Davy - 2000