function [TFR,T,F]=Ctfrpage(X,T,N)
// Page time-frequency distribution.
// Calling Sequence
// [TFR,T,F]=Ctfrpage(X)
// [TFR,T,F]=Ctfrpage(X,T)
// [TFR,T,F]=Ctfrpage(X,T,N)
// Parameters
// X     : Analyzed signal.
// T     : time instant(s)          (default : 1:length(X)).
// N     : number of frequency bins (default : length(X)).
//
// TFR   : time-frequency representation.
// F     : vector of normalized frequencies.
//
// Examples
//   x = hilbert(sin(2*%pi*0.25*(1:128))+0.5*rand(1,128,'normal'));  
//   t=1:128; [tfr,T,F]=Ctfrpage(x,t,128);
//   grayplot(T,F,tfr'); xlabel('time'); ylabel('frequency')
// Description
// Computes the Page distribution for a signal X. 
// See also
//    Ctfrri
//    Ctfrppage
// Authors
// H. Nahrstaedt - Sep 2010
// Emmanuel Roy - 2000
// Manuel Davy - 2000


