function TFR_reas = Ctfrreas(TFR,field_time,field_freq)
// Time Frequency Representation reassignment
// Calling Sequence
// TFR_reas = Ctfrreas(TFR,field_time,field_freq)
// Parameters
// TFR         : TFR to be reassigned  
// field_time  : Time component of the field of reassignment     vectors
// field_freq  : Frequency component of the field of     reassignment vectors
// 
// TFR_reas    : Reassigned TFR
// Description
// Reassigns the pixels of a TFR, given a field of reassignment
// vectors.
// Examples
// [SP_reas,SP,field]=Ctfrrsp(hilbert(sin(2*%pi*0.25*(1:128)))+0.5*rand(1,128,'normal'));
// SP_reas2=Ctfrreas(SP,real(field),imag(field));
// grayplot(1:128,1:128,SP_reas'); 
// scf(); grayplot(1:128,1:128,SP_reas2'); 
//
// See also 
//Ctfrrsp
// Authors
// H. Nahrstaedt - Sep 2010
// Emmanuel Roy - 2000
// Manuel Davy - 2000