function [TFR,T,F]=Ctfrri(X,T,N)
//  Rihaczek time-frequency distribution.
// Calling Sequence
// [TFR,T,F]=Ctfrri(X)
// [TFR,T,F]=Ctfrri(X,T)
// [TFR,T,F]=Ctfrri(X,T,N)
// Parameters
// X     : Analyzed signal.
// T     : time instant(s)          (default : 1:length(X)).
// N     : number of frequency bins (default : length(X)).
//
// TFR   : time-frequency representation.
// F     : vector of normalized frequencies.
//
// Description
//    Computes the Rihacez distribution for a signal X. 
// Examples
//   x = hilbert(sin(2*%pi*0.25*(1:128))+0.5*rand(1,128,'normal'));  
//   t=1:128; [tfr,T,F]=Ctfrri(x,t,128);
//   grayplot(T,F,abs(tfr)'); xlabel('time'); ylabel('frequency')
//
// See also
//   Ctfrridb 
//   Ctfrridh
//   Ctfrridt
// Authors
// H. Nahrstaedt - Sep 2010
// Emmanuel Roy - 2000
// Manuel Davy - 2000




