function [SP_reas,SP,FIELD] = Ctfrrsp(X,T,N,H)
// Reassigned Spectrogram
// Calling Sequence
// [SP_reas,SP,FIELD] = Ctfrrsp(X)
// [SP_reas,SP,FIELD] = Ctfrrsp(X,T)
// [SP_reas,SP,FIELD] = Ctfrrsp(X,T,N)
// [SP_reas,SP,FIELD] = Ctfrrsp(X,T,N,H)
// Parameters
// X        : Analyzed signal
// T        : the time instant(s)   (default : 1:length(X)).
// N        : number of frequency bins (default : length(X)).
// H        : frequency smoothing window, (default : Hamming(N/4)).
//
// SP_reas  : Reassigned spectrogram 
// SP       : Spectrogram (not reassigned)
// FIELD    : Field of reassignment vectors
// Description
// Computes the reassigned spectrogram, the spectrogram and the
// field of reassignment vectors
// Examples
//       SP_reas=Ctfrrsp(hilbert(sin(2*%pi*0.25*(1:128)))+0.5*rand(1,128,'normal'));
//       grayplot(1:128,1:128,SP_reas'); 
// See also
//Ctfrreas
//Cwindow
// Authors
// H. Nahrstaedt - Sep 2010
// Emmanuel Roy - 2000
// Manuel Davy - 2000
