function [SP,T,F,norm] = Ctfrsp(X,T,N,H)
// Spectrogram Time Frequency distribution of a signal X
// Calling Sequence
// [SP,T,F,norm] = Ctfrsp(X)
// [SP,T,F,norm] = Ctfrsp(X,T)
// [SP,T,F,norm] = Ctfrsp(X,T,N)
// [SP,T,F,norm] = Ctfrsp(X,T,N,H)
// Parameters
// X        : Analyzed signal
// T        : the time instant(s)   (default : 1:length(X)).
// N        : number of frequency bins (default : length(X)).
// H        : frequency smoothing window, (default : Hamming(N/4)).
// SP       : Spectrogram
// F         : Vector of frequency bins
// NORM      : Vector of normalization applied at each time instant
// Description
// Computes the  spectrogram of a signal X
// Examples
//    x = hilbert(sin(2*%pi*0.25*(1:128))+0.5*rand(1,128,'normal'));
//    [sp,T,F] = Ctfrsp(x,1:128,128);
//    grayplot(T,F,sp');
// See also
// Ctfrrsp
// Ctfrstft
// Ctfrwv
// Cwindow
// Authors
// H. Nahrstaedt - Sep 2010
// Emmanuel Roy - 2000
// Manuel Davy - 2000