function [STFT,T,F,NORM] = Ctfrstft(X,T,N,H);
// Short time Fourier transform
// Calling Sequence
// [STFT,T,F,NORM] = Ctfrstft(X);
//[STFT,T,F,NORM] = Ctfrstft(X,T);
// [STFT,T,F,NORM] = Ctfrstft(X,T,N);
// [STFT,T,F,NORM] = Ctfrstft(X,T,N,H);
// Parameters
// X         : signal for which the STFT is computed
// T         : time instant(s)          (default : 1:length(X)).
// N         : number of frequency bins (default : length(X)).
// H         : frequency smoothing window (default : Hamming(N/4)). 
//
// STFT      : Computed Short time Fourier Transform
// F         : Vector of frequency bins
// NORM      : Vector of normalization applied at each time instant
// Desciption
// Computes the Short Time Fourier Transform (STFT) of Signal
// Examples
//    //Spectrogram of a tone embedded in noise
//    x = hilbert(sin(2*%pi*0.25*(1:128))+0.5*rand(1,128,'normal'));
//    [stft,T,F] = Ctfrstft(x,1:128,128);
//    grayplot(T,F,(abs(stft).^2)'); 
//
// See also 
//Ctfrsp
//Ctfrrsp
//Cwindow
// Authors
// H. Nahrstaedt - Sep 2010
// Emmanuel Roy - 2000
// Manuel Davy - 2000