function [TFR,T,F]=Ctfrwv(X,T,N)
//	 Wigner-Ville time-frequency distribution.
// Calling Sequence
// [TFR,T,F]=Ctfrwv(X)
//[TFR,T,F]=Ctfrwv(X,T)
// [TFR,T,F]=Ctfrwv(X,T,N)
// Parameters
// X     : Analyzed signal.
// T     : time instant(s)          (default : 1:length(X)).
// N     : number of frequency bins (default : length(X)).
//
// TFR   : time-frequency representation.
// F     : vector of normalized frequencies.
//
// Description
//  computes the Wigner-Ville distribution of a  signal X. 
// Examples
//   x = hilbert(sin(2*%pi*0.25*(1:128))+0.5*rand(1,128,'normal'));  
//   t=1:128; [tfr,T,F]=Ctfrwv(x,t,128);
//   grayplot(T,F,tfr'); xlabel('time'); ylabel('frequency')
// See also
//Ctfrpwv
//Ctfrspwv
// Authors
// H. Nahrstaedt - Sep 2010
// Emmanuel Roy - 2000
// Manuel Davy - 2000