/* Interface program between MATLAB and language C
for the progrma DISTANCE.C */

//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

// #include "tftb.h"
// 
#define TFR1            1
#define TFR2             2
#define DIST_NAME        3
#define DIST_COEF       4
// 
// #define DISTANCE_OUT     plhs[0]
// 
// #include "divers.c"
// #include "distance.c"
#include <stdlib.h>
#include <stdio.h>
// #include <stack-c.h>
#include "tftb.h"

/* at the moment , complex TFRs are not accepted */
int 
int_Ctfrdist(char *fname)


{
  type_TFR       first_TFR, second_TFR;
  double         coef, *dist;
  int            dist_name_length;
  int            N_time, N_freq, dist_name;
  char          *dist_name_string;

    SciErr sciErr;
  int* piAddressVar     = NULL;
  int iType = 0;  
  int mVar = 0, nVar = 0;
  
  if ((Rhs < 3) || (Rhs > 4)){
    Scierror (999,"Dist=Ctfrdist(TFR1,TFR2,distance_name,distance_coef)");
       return 0;
  }
  CheckRhs (3,4);
  CheckLhs (1,1);
   
  /* Recovery of TFRs */
//   first_TFR.real_part = mxGetPr (TFR1);
  
   sciErr = getVarAddressFromPosition(pvApiCtx, TFR1, &piAddressVar);
    if(sciErr.iErr)
    {
      printError(&sciErr, 0);
      return 0;
    } 
      sciErr = getMatrixOfDouble(pvApiCtx, piAddressVar, &mVar, &nVar, &first_TFR.real_part);
    if(sciErr.iErr)
    {
      printError(&sciErr, 0);
      return 0;
    } 
    
   first_TFR.N_time = mVar;
  first_TFR.N_freq = nVar;
    first_TFR.is_complex = FALSE;
  
//   second_TFR.real_part = mxGetPr (TFR2);
     sciErr = getVarAddressFromPosition(pvApiCtx, TFR2, &piAddressVar);
    if(sciErr.iErr)
    {
      printError(&sciErr, 0);
      return 0;
    } 
      sciErr = getMatrixOfDouble(pvApiCtx, piAddressVar, &mVar, &nVar, &second_TFR.real_part);
    if(sciErr.iErr)
    {
      printError(&sciErr, 0);
      return 0;
    } 
   second_TFR.N_time = mVar;
  second_TFR.N_freq = nVar;
  second_TFR.is_complex = FALSE;


  /* TFRs dimensions recovery */
//   first_TFR.N_time = mxGetM (TFR1);
//   first_TFR.N_freq = mxGetN (TFR1);
//   second_TFR.N_time = mxGetM (TFR2);
//   second_TFR.N_freq = mxGetN (TFR2);

  if ((first_TFR.N_time != second_TFR.N_time) ||   (first_TFR.N_freq != second_TFR.N_freq)){
    Scierror (999,"The two TFR do not have the same size\n");
    return 0;
  }

  /* recovery of the ditance name */
  
//   if(!mxIsChar(DIST_NAME)){
//     Scierror (999,"Variable distance_name must contain a string.\n");
//       return 0;
//   }
//   dist_name_length = mxGetN(DIST_NAME)+1;
//   dist_name_string = (char *) ALLOC (dist_name_length,sizeof(char));
//   mxGetString(DIST_NAME,dist_name_string,dist_name_length);

  dist_name_length = sciGetStringLength(pvApiCtx,DIST_NAME, &sciErr);
  if(sciErr.iErr)
  {
    printError(&sciErr, 0);
    return 0;
  }
  dist_name_string = (char *) ALLOC (dist_name_length,sizeof(char));
  sciGetString(pvApiCtx,DIST_NAME, &sciErr, dist_name_string );
  if(sciErr.iErr)
  {
    printError(&sciErr, 0);
    return 0;
  }
  
  /* distance name recovery */
  dist_name = 0;
 

  if((!(strcmp(dist_name_string,"Lq"))) ||
     (!(strcmp(dist_name_string,"LQ"))) ||
     (!(strcmp(dist_name_string,"lq"))))
    {
      dist_name = LQ;
    }

  if((!(strcmp(dist_name_string,"Quadratic"))) ||
     (!(strcmp(dist_name_string,"QUADRATIC"))) ||
     (!(strcmp(dist_name_string,"quadratic"))))
     {
       dist_name = QUADRATIC;
     }

  if((!(strcmp(dist_name_string,"Correlation"))) ||
     (!(strcmp(dist_name_string,"CORRELATION"))) ||
     (!(strcmp(dist_name_string,"correlation"))))
     {
       dist_name = CORRELATION;
     }

  if((!(strcmp(dist_name_string,"Kolmogorov"))) ||
     (!(strcmp(dist_name_string,"KOLMOGOROV"))) ||
     (!(strcmp(dist_name_string,"kolmogorov"))))
     {
       dist_name = KOLMOGOROV;
     }
    
  if((!(strcmp(dist_name_string,"Kullback"))) ||
     (!(strcmp(dist_name_string,"KULLBACK"))) ||
     (!(strcmp(dist_name_string,"kullback"))))
     {
       dist_name = KULLBACK;
     }
  if((!(strcmp(dist_name_string,"Chernoff"))) ||
      (!(strcmp(dist_name_string,"CHERNOFF"))) ||
      (!(strcmp(dist_name_string,"chernoff"))))
     {
       dist_name = CHERNOFF;
     }
     
   if((!(strcmp(dist_name_string,"Matusita"))) ||
      (!(strcmp(dist_name_string,"MATUSITA"))) ||
      (!(strcmp(dist_name_string,"matusita"))))
     {
       dist_name = MATUSITA;
     }
 
 
   if((!(strcmp(dist_name_string,"NLq"))) ||
      (!(strcmp(dist_name_string,"NLQ"))) ||
      (!(strcmp(dist_name_string,"nlq"))))
     {
       dist_name = NLQ;
     }


   if((!(strcmp(dist_name_string,"Lsd"))) ||
      (!(strcmp(dist_name_string,"LSD"))) ||
      (!(strcmp(dist_name_string,"lsd"))))
     {
       dist_name = LSD;
     }
     
  if((!(strcmp(dist_name_string,"Jensen"))) ||
     (!(strcmp(dist_name_string,"JENSEN"))) ||
     (!(strcmp(dist_name_string,"jensen"))))
     {
       dist_name = JENSEN;
     }
 
  if (dist_name == 0)
    {
      Scierror (999,"Unknown distance name");
        free (dist_name_string);
      return 0;
    }


  /* some tests about the distence coef */
  /* to have or not to have a coefficient ? */

  if ((dist_name == LQ)       || (dist_name == CHERNOFF) ||
      (dist_name == MATUSITA) ||(dist_name == NLQ) || 
      (dist_name == LSD)      || (dist_name == JENSEN))
    {
      if (Rhs == 3) /* cases where there should be a coef given */
	{
	  Scierror (999,"A coefficient is required for this distance");
	    free (dist_name_string);
	  return 0;
	}
    }
 


  /* Distance coefficient recovery */
  if (Rhs == 4)
    {
//       coef = mxGetScalar (DIST_COEF);
      coef = sciGetDoubleScalar(pvApiCtx,DIST_COEF,  &sciErr);
      if(sciErr.iErr)
      {
	printError(&sciErr, 0);
	return 0;
      }
    }
  else
    {
      coef = 1.0;
    }


  /* Error cases */
  if ((dist_name == LQ) && (coef <= 0)){
    Scierror (999,"distance_coef > 0 for Lq distance");
     free (dist_name_string);
        return 0;
  }

  if ((dist_name == CHERNOFF) && ((coef > 1) || (coef < 0))){
    Scierror (999,"0 <= distance_coef <= 1 for Chernoff distance");
     free (dist_name_string);
        return 0;
  }

  if ((dist_name == MATUSITA) && (coef < 1)){
    Scierror (999,"distance_coef >= 1 for Generalized Matusita distance");
     free (dist_name_string);
        return 0;
  }

  if ((dist_name == NLQ) && (coef <= 0)){
    Scierror (999,"distance_coef > 0 for Normalized Lq distance");
     free (dist_name_string);
        return 0;
  }

  if ((dist_name == LSD) && (coef <= 0)){
    Scierror (999,"distance_coef > 0 for q-Log Spectral Deviation");
     free (dist_name_string);
        return 0;
  }

  if ((dist_name == JENSEN) && (coef <= 0)){
    Scierror (999,"distance_coefq > 0 for q-Jensen divergence");
     free (dist_name_string);
        return 0;
  }

  if ((dist_name != LQ) && (dist_name != QUADRATIC) &&
      (dist_name != CORRELATION) && (dist_name != KOLMOGOROV) &&
      (dist_name != KULLBACK) && (dist_name != CHERNOFF) &&
      (dist_name != MATUSITA) && (dist_name != NLQ) &&
      (dist_name != LSD) && (dist_name != JENSEN)){
    Scierror (999,"Bad distance identification number");
   free (dist_name_string);
      return 0;
  }


  /* Creation of the output variable */
//   DISTANCE_OUT = mxCreateDoubleMatrix (1, 1, mxREAL);

  /* pointer on the results dist */
//   dist = mxGetPr (DISTANCE_OUT);
  
 dist = (double*)ALLOC(1, sizeof(double));


  /* computation of the distance */
  distance (first_TFR, second_TFR, dist_name, coef, dist);
  
 sciErr = createMatrixOfDouble(pvApiCtx, Rhs + 1, 1, 1, dist);
   if(sciErr.iErr)
  {
    printError(&sciErr, 0);
    return 0;
  } 
  
  free(dist);
  free (dist_name_string);
      LhsVar(1) = Rhs + 1; 
    PutLhsVar();
    return 0;

}

