//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
/* interface program between MATLAB and language C
  for Reassign.C */
// #include "tftb.h"
// 
#define TFR            1
#define FIELD_X         2
#define FIELD_Y         3
// 
// #define TFR_REAS_OUT    plhs[0]
// 
// #include "divers.c"
// #include "reassign.c"
#include <stdlib.h>
#include <stdio.h>
// #include <stack-c.h>
#include "tftb.h"
int 
int_Ctfrreas(char *fname)


{
  double        *field_x, *field_y;
  type_TFR       TFR_to_reassign, TFR_reassigned;

  SciErr sciErr;
  int* piAddressVar     = NULL;
  int iType = 0;  
  int mVar = 0, nVar = 0;
  
  if (!(Rhs == 3)){
    Scierror (999,"TFR_REAS=Ctfrreas(TFR,field_x,field_y)");
    return 0;
  }

 CheckRhs (3,3);
  CheckLhs (1,1);

  /* Recovery of the tfr parameter */
     sciErr = getVarAddressFromPosition(pvApiCtx, TFR, &piAddressVar);
    if(sciErr.iErr)
    {
      printError(&sciErr, 0);
      return 0;
    } 
     /* check input type */
  sciErr = getVarType(pvApiCtx, piAddressVar, &iType);
  if(sciErr.iErr)
  {
    printError(&sciErr, 0);
    return 0;
  } 
    if ( iType != sci_matrix )
  {
    Scierror(999," TFR  must be a matrix.\n");
    return 0;
  }
      sciErr = getMatrixOfDouble(pvApiCtx, piAddressVar, &mVar, &nVar, &TFR_to_reassign.real_part);
    if(sciErr.iErr)
    {
      printError(&sciErr, 0);
      return 0;
    } 
    

  /* TFR dimensions recovery */
  TFR_to_reassign.N_time = nVar;//mxGetN (TFR);
  TFR_to_reassign.N_freq = mVar;//mxGetM (TFR);
    /* Recovery of TFR to reassign */
//   TFR_to_reassign.real_part = mxGetPr (TFR);
  TFR_to_reassign.is_complex = FALSE;
  
      sciErr = getVarAddressFromPosition(pvApiCtx, 2, &piAddressVar);
  if(sciErr.iErr)
  {
    printError(&sciErr, 0);
    return 0;
  } 
    /* check input type */
  sciErr = getVarType(pvApiCtx, piAddressVar, &iType);
  if(sciErr.iErr)
  {
    printError(&sciErr, 0);
    return 0;
  } 
    if ( iType != sci_matrix )
  {
    Scierror(999," Field  must be a matrix.\n");
    return 0;
  }
  sciErr = getMatrixOfDouble(pvApiCtx, piAddressVar,&mVar,&nVar,&field_x);
  if(sciErr.iErr)
  {
    printError(&sciErr, 0);
    return 0;
  }

  if (( TFR_to_reassign.N_freq != mVar) || (TFR_to_reassign.N_time != nVar ) ){
    Scierror(999,"Time frequency matrix and field  must be the same size");
    return 0;
  }

      sciErr = getVarAddressFromPosition(pvApiCtx, 3, &piAddressVar);
  if(sciErr.iErr)
  {
    printError(&sciErr, 0);
    return 0;
  } 
    /* check input type */
  sciErr = getVarType(pvApiCtx, piAddressVar, &iType);
  if(sciErr.iErr)
  {
    printError(&sciErr, 0);
    return 0;
  } 
    if ( iType != sci_matrix )
  {
    Scierror(999," Field  must be a matrix.\n");
    return 0;
  }
  sciErr = getMatrixOfDouble(pvApiCtx, piAddressVar,&mVar,&nVar,&field_y);
  if(sciErr.iErr)
  {
    printError(&sciErr, 0);
    return 0;
  }

  if (( TFR_to_reassign.N_freq != mVar) || (TFR_to_reassign.N_time != nVar ) ){
    Scierror(999,"Time frequency matrix and field  must be the same size");
    return 0;
  }


  /* recovery of the field */
//   field_x = mxGetPr (FIELD_X);
//   field_y = mxGetPr (FIELD_Y);



  /* Creation of the output variable */
  TFR_reassigned.N_time = TFR_to_reassign.N_time;
  TFR_reassigned.N_freq = TFR_to_reassign.N_freq;
  TFR_reassigned.real_part=  (double*)malloc(sizeof(double) * TFR_reassigned.N_freq*TFR_reassigned.N_time ); 
  //TFR_REAS_OUT = mxCreateDoubleMatrix (TFR_reassigned.N_freq,   TFR_reassigned.N_time, mxREAL);
  memset(TFR_reassigned.real_part,0,sizeof(double) * TFR_reassigned.N_freq*TFR_reassigned.N_time);

  TFR_reassigned.is_complex = FALSE;
  /* pointer on the results dist */
//   TFR_reassigned.real_part = mxGetPr (TFR_REAS_OUT);


  /* Reassignement of the TFR matrix according to the field of vectors */
  reassign (TFR_to_reassign, field_x, field_y, TFR_reassigned);
  
   sciErr =  createMatrixOfDouble(pvApiCtx, Rhs + 1, TFR_reassigned.N_freq, TFR_reassigned.N_time, TFR_reassigned.real_part);
    if(sciErr.iErr)
  {
    printError(&sciErr, 0);
    return 0;
  } 
  free(TFR_reassigned.real_part);
  LhsVar(1) = Rhs + 1; 
  PutLhsVar();
  
  return 0;
}
