//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#define SIGNAL           1
#define TIME_INST        2
#define NFFT             3
// 
// #define RI_OUT           plhs[0]
// #define TIME_OUT         plhs[1]
// #define FREQ_OUT         plhs[2]
// 
// #include "tftb.h"
// #include "divers.c"
// #include "create_window.c"
// #include "ri.c"
#include <stdlib.h>
#include <stdio.h>
// #include <stack-c.h>
#include "tftb.h"
int 
int_Ctfrri(char *fname)

{
  type_signal    Signal;
  type_TFR       tfr;
  double        *ptr_time_inst, *ptr_freq_vect, *time_out;
  int            i;
   int retval;
   
    SciErr sciErr;
  int* piAddressVar     = NULL;
  int iType = 0;  
  int mVar = 0, nVar = 0;


  /* tests the number of inputs and outputs */
  if ((Rhs < 1) || (Rhs > 3) || (Lhs < 1) || (Lhs > 3)){
      Scierror (999,"[TFR,t,f]=CTFRRI(Signal,Time_instants,Number of frequencies)");
   return 0;
  }
  CheckRhs (1,3);
  CheckLhs (1,3);


   sciErr = getVarAddressFromPosition(pvApiCtx, 1, &piAddressVar);
  if(sciErr.iErr)
  {
    printError(&sciErr, 0);
    return 0;
  } 
    /* check input type */
  sciErr = getVarType(pvApiCtx, piAddressVar, &iType);
  if(sciErr.iErr)
  {
    printError(&sciErr, 0);
    return 0;
  } 
  if ( isVarComplex(pvApiCtx, piAddressVar)){
  sciErr = getComplexMatrixOfDouble(pvApiCtx, piAddressVar, &mVar, &nVar, &Signal.real_part, &Signal.imag_part );
  if(sciErr.iErr)
  {
    printError(&sciErr, 0);
    return 0;
  } 
  Signal.is_complex = TRUE;
  
  } else {
      sciErr = getMatrixOfDouble(pvApiCtx, piAddressVar, &mVar, &nVar, &Signal.real_part);
  if(sciErr.iErr)
  {
    printError(&sciErr, 0);
    return 0;
  } 
    
    Signal.is_complex = FALSE;
  }
  /* recovery of the signal */
  if (mVar > 1 && nVar > 1){
    Scierror (999,"%s: Wrong size for argument %d: Vector expected.\n", fname, 1);
    return 0;
  } 
  Signal.length = mVar*nVar;
  if (Signal.length == 0){
    Scierror (999,"%s: Wrong size for input argument #%d: Non-empty matrix expected.\n", fname, 1);
    return 0;
  }
//   Signal.real_part = mxGetPr (SIGNAL);
//   if (mxIsComplex (SIGNAL))
//     {
//       Signal.imag_part = mxGetPi (SIGNAL);
//       Signal.is_complex = TRUE;
//     }
//   else
//     {
//       Signal.is_complex = FALSE;
//     }

  /* if there are not the three inputs ... */

  if (Rhs >= 2)		/* the time instants are given */
    {
//       tfr.N_time = (int) MAX (mxGetM (TIME_INST), mxGetN (TIME_INST));
//       ptr_time_inst = mxGetPr (TIME_INST);
 sciErr = getVarAddressFromPosition(pvApiCtx, TIME_INST, &piAddressVar);
    if(sciErr.iErr)
    {
      printError(&sciErr, 0);
      return 0;
    } 
      sciErr = getMatrixOfDouble(pvApiCtx, piAddressVar, &mVar, &nVar, &ptr_time_inst);
    if(sciErr.iErr)
    {
      printError(&sciErr, 0);
      return 0;
    } 
      if (mVar > 1 && nVar > 1){
        Scierror (999,"%s: Wrong size for argument %d: Vector expected.\n", fname, 2);
        return 0;
      }
      tfr.N_time  = mVar*nVar;
      if ( tfr.N_time == 0){
        Scierror (999,"%s: Wrong size for input argument #%d: Non-empty matrix expected.\n", fname, 2);
        return 0;
      }
    }
  else
    /* the time instants are no given */
    {
      /* default : Time_instants = 1:Signal_Length */
      tfr.N_time = Signal.length;
      ptr_time_inst = NULL;
    }

  if (Rhs >= 3)		/* the number of frequencies is given */
    {
//       tfr.N_freq = (int) mxGetScalar (NFFT);
 tfr.N_freq = sciGetUIntScalar(pvApiCtx,NFFT,  &sciErr);
      if(sciErr.iErr)
      {
	printError(&sciErr, 0);
	return 0;
      }
      if (tfr.N_freq <= 0 ) {
        Scierror (999, "%s: Wrong argument #%d: Positive integer expected.\n", fname, NFFT);
        return 0;
      }
    }
  else
    /* the number of frequencies is not given */
    {
      /* default : Nfft = length of the signal */
      tfr.N_freq = Signal.length;
    }


  /* case of the third output : FREQ_OUT vector of frequency bins */
//   if (Lhs >= 3)
//     {
//       FREQ_OUT = mxCreateDoubleMatrix (1, tfr.N_freq, mxREAL);
//       ptr_freq_vect = mxGetPr (FREQ_OUT);
//     }
//   else
//     {
      ptr_freq_vect = NULL;
//     }


  /* creation of the output complex matrix */
  tfr.is_complex = TRUE;
//   RI_OUT = mxCreateDoubleMatrix (tfr.N_freq, tfr.N_time, mxCOMPLEX);
  retval=mem_alloc_TFR (&tfr, ptr_freq_vect, ptr_time_inst, NULL,NULL); //mxGetPr (RI_OUT),		 mxGetPi (RI_OUT));
  if (retval == 4) {
    Scierror (999,"%s : Memory allocation error.\n",fname); 
    return 0;
  }
  /* creation of the time_instants vector if not given */
  if (ptr_time_inst == NULL)
    {
      for (i = 0; i < tfr.N_time; i++)
	{
	  tfr.time_instants[i] = i + 1.0;
	}
    }



  /* case of the second output */
//   if (Lhs >= 2)
//     {
//       TIME_OUT = mxCreateDoubleMatrix (1, tfr.N_time, mxREAL);
//       time_out = mxGetPr (TIME_OUT);
//       for (i = 0; i < tfr.N_time; i++)
// 	{
// 	  time_out[i] = tfr.time_instants[i];
// 	}
//     }

  /* ---------------------------------------------------- */
  /*             calls the computation function           */
  /* ---------------------------------------------------- */

  retval = ri(Signal, tfr);
  if (retval == 6) {
    
    Scierror (999,"%s : Memory allocation error.\n",fname); 
    return 0;
  }
    sciErr =  createComplexMatrixOfDouble(pvApiCtx, Rhs + 1, tfr.N_freq, tfr.N_time, tfr.real_part, tfr.imag_part);
      if(sciErr.iErr)
    {
      printError(&sciErr, 0);
      return 0;
    } 
    free(tfr.real_part);
    free(tfr.imag_part);
   LhsVar(1) = Rhs + 1; 
    if (Lhs >= 2)
    {
        sciErr =  createMatrixOfDouble(pvApiCtx, Rhs + 2, 1, tfr.N_time, tfr.time_instants);
	  if(sciErr.iErr)
	{
	  printError(&sciErr, 0);
	  return 0;
	} 
       LhsVar(2) = Rhs + 2; 
    }
      if (Lhs >= 3)
    {
       sciErr =  createMatrixOfDouble(pvApiCtx, Rhs + 3, 1, tfr.N_freq, tfr.freq_bins);
         if(sciErr.iErr)
	{
	  printError(&sciErr, 0);
	  return 0;
	} 
      LhsVar(3) = Rhs + 3; 
    }

  /* ---------------------------------------------------- */
  /*                     Free the memory                  */
  /* ---------------------------------------------------- */

  if (Rhs < 2)
    {
      free (tfr.time_instants);
    }

      free (tfr.freq_bins);
    
        PutLhsVar();
  
  return 0;

}
