//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
/* Interface program between MATLAB and language C
for the program CREATE_WINDOW.C */


#include <stdlib.h>
#include <stdio.h>
// #include <stack-c.h>
#include "tftb.h"

#define LENGTH           1
#define WINDOW_NAME      2
#define PARAM1           3
#define PARAM2           4 
// 
#define WINDOW_OUT       1

//#include "divers.c"
//#include "create_window.c"

/* at the moment , complex TFRs are not accepted */


int 
int_Cwindow(char *fname)

{
 int       Window_length, Window_name, nb_param;
 int       Window_name_length;
 double   *param, *Window;
 char*      Window_name_string;

  SciErr sciErr;
  int* piAddressVar     = NULL;
  int iType = 0;  
  int mVar = 0, nVar = 0;
  
  /* checks the number of inputs */
  if ((Rhs < 2) || (Rhs > 4)){
    Scierror(999,"Window=Ctfrwindow(length,'name'[,param1, param2])");
    return 0;
  }
  CheckRhs (2,4);
  CheckLhs (1,1);

   
  /* recovery of the length */
  //Window_length = mxGetScalar(LENGTH);
  
  Window_length = sciGetUIntScalar(pvApiCtx,LENGTH,  &sciErr);
  if(sciErr.iErr)
  {
    printError(&sciErr, 0);
    return 0;
  }
  if (Window_length <= 0 ) {
        Scierror (999, "%s: Wrong argument #%d: Positive integer expected.\n", fname, LENGTH);
        return 0;
  }
      
  //Window_name_length = mxGetN(WINDOW_NAME)+1;
  //Window_name_string = (char *) ALLOC (Window_name_length,sizeof(char));
  //mxGetString(WINDOW_NAME,Window_name_string,Window_name_length);
  Window_name_length = sciGetStringLength(pvApiCtx,WINDOW_NAME, &sciErr);
  if(sciErr.iErr)
  {
    printError(&sciErr, 0);
    return 0;
  }
  Window_name_string = (char *) ALLOC (Window_name_length,sizeof(char));
  sciGetString(pvApiCtx,WINDOW_NAME, &sciErr, Window_name_string );
  if(sciErr.iErr)
  {
    printError(&sciErr, 0);
    return 0;
  }
  /* window name recovery */
  Window_name = 0;
 
  if((!(strcmp(Window_name_string,"HAMMING"))) ||
     (!(strcmp(Window_name_string,"hamming"))) ||
     (!(strcmp(Window_name_string,"Hamming"))))
    {
      Window_name = HAMMING;
    }
  if((!(strcmp(Window_name_string,"HANNING"))) ||
     (!(strcmp(Window_name_string,"hanning"))) ||
     (!(strcmp(Window_name_string,"Hanning"))))
    {
      Window_name = HANNING;
    }
  if((!(strcmp(Window_name_string,"NUTTALL"))) ||
     (!(strcmp(Window_name_string,"nuttall"))) ||
     (!(strcmp(Window_name_string,"Nuttall"))))
    {
      Window_name = NUTTALL;
    }
  if((!(strcmp(Window_name_string,"PAPOULIS"))) ||
     (!(strcmp(Window_name_string,"papoulis"))) ||
     (!(strcmp(Window_name_string,"Papoulis"))))
    {
      Window_name = PAPOULIS;
    }
  if((!(strcmp(Window_name_string,"HARRIS"))) ||
     (!(strcmp(Window_name_string,"harris"))) ||
     (!(strcmp(Window_name_string,"Harris"))))
    {
      Window_name = HARRIS;
    }
  if((!(strcmp(Window_name_string,"RECT"))) ||
     (!(strcmp(Window_name_string,"rect"))) ||
     (!(strcmp(Window_name_string,"Rect"))))
    {
      Window_name = RECTANG;
    }
  if((!(strcmp(Window_name_string,"TRIANG"))) ||
     (!(strcmp(Window_name_string,"triang"))) ||
     (!(strcmp(Window_name_string,"Triang"))))
    {
      Window_name = TRIANG;
    }
  if((!(strcmp(Window_name_string,"BARTLETT"))) ||
     (!(strcmp(Window_name_string,"bartlett"))) ||
     (!(strcmp(Window_name_string,"Bartlett"))))
    {
      Window_name = BARTLETT;
    }
  if((!(strcmp(Window_name_string,"BARTHANN"))) ||
     (!(strcmp(Window_name_string,"barthann"))) ||
     (!(strcmp(Window_name_string,"BartHann"))))
    {
      Window_name = BARTHANN ;
    }
  if((!(strcmp(Window_name_string,"BLACKMAN"))) ||
     (!(strcmp(Window_name_string,"blackman"))) ||
     (!(strcmp(Window_name_string,"Blackman"))))
    {
      Window_name = BLACKMAN ;
    }
  if((!(strcmp(Window_name_string,"GAUSS"))) ||
     (!(strcmp(Window_name_string,"gauss"))) ||
     (!(strcmp(Window_name_string,"Gauss"))))
    {
      Window_name = GAUSS;
    }
  if((!(strcmp(Window_name_string,"PARZEN"))) ||
     (!(strcmp(Window_name_string,"parzen"))) ||
     (!(strcmp(Window_name_string,"Parzen"))))
    {
      Window_name = PARZEN;
    }
  if((!(strcmp(Window_name_string,"DOLPH"))) ||
     (!(strcmp(Window_name_string,"dolph"))) ||
     (!(strcmp(Window_name_string,"Dolph"))))
    {
      Window_name = DOLPH;
    }
  if((!(strcmp(Window_name_string,"DOLF"))) ||
     (!(strcmp(Window_name_string,"dolf"))) ||
     (!(strcmp(Window_name_string,"Dolf"))))
    {
      Window_name = DOLF;
    }
  if((!(strcmp(Window_name_string,"HANNA"))) ||
     (!(strcmp(Window_name_string,"hanna"))) ||
     (!(strcmp(Window_name_string,"Hanna"))))
    {
      Window_name = HANNA;
    }
   if((!(strcmp(Window_name_string,"NUTBESS"))) ||
     (!(strcmp(Window_name_string,"nutbess"))) ||
     (!(strcmp(Window_name_string,"Nutbess"))))
    {
      Window_name = NUTBESS;
    }
  if((!(strcmp(Window_name_string,"SPLINE"))) ||
     (!(strcmp(Window_name_string,"spline"))) ||
     (!(strcmp(Window_name_string,"Spline"))))
    {
      Window_name = SPLINE;
    }
 if (Window_name == 0)
    {
      Scierror(999,"Unknown window type %s\n",Window_name_string);
       free(Window_name_string);
      return 0;
    }



  nb_param = 0;
  param = NULL;

  /* recovery of the parameters */ 
  if (Rhs == 4)
    {
      nb_param = 2;
      param = (double *) ALLOC (2, sizeof(double));
      //param[0] = mxGetScalar(PARAM1);
       param[0] = sciGetDoubleScalar(pvApiCtx,PARAM1,  &sciErr);
         if(sciErr.iErr)
	{
	  printError(&sciErr, 0);
	  return 0;
	}
       //param[1] = mxGetScalar(PARAM2);
        param[1] = sciGetDoubleScalar(pvApiCtx,PARAM2,  &sciErr); 
	  if(sciErr.iErr)
	  {
	    printError(&sciErr, 0);
	    return 0;
	  }

    }
 if (Rhs == 3)
    {
      nb_param = 1;
      param = (double *) ALLOC (1, sizeof(double));
      //param[0] = mxGetScalar(PARAM1);
      param[0] = sciGetDoubleScalar(pvApiCtx,PARAM1,  &sciErr);
        if(sciErr.iErr)
	{
	  printError(&sciErr, 0);
	  return 0;
	}
    }

 

  /* Creation of the output variable */
  //WINDOW_OUT = mxCreateDoubleMatrix (Window_length, 1, mxREAL);

  /* pointer on the results dist */
  //Window = mxGetPr (WINDOW_OUT);
  Window = (double*) ALLOC(Window_length, sizeof(double) );

  /* computation of the distance */
  create_window(Window_name, Window_length, param, nb_param, Window);
 sciErr = createMatrixOfDouble(pvApiCtx, Rhs + 1, Window_length, 1, Window);
   if(sciErr.iErr)
  {
    printError(&sciErr, 0);
    return 0;
  } 
  free(Window);
    
 if (Rhs > 2)
    {
      free (param);
    }
  free(Window_name_string);
  //free(Window_name_string);

  LhsVar(1) = Rhs + 1; 
    PutLhsVar();
  
  return 0;
}

