mode(-1)
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
//function ambifunt
//AMBIFUNT Unit test for the function ambifunb.

//	O. Lemoine - December 1995.
//	F. Auger - February 1996.

N=128; 
// if ~isdef('Cambifunb')  then
//   error("Function not defined, please load the toolbox stf!");
// end
// Ambiguity function of a pulse
sig=sum(((1:N)'==40),'c'); 
amb=Cambifunb(sig);
[ik,jk]=find(amb~=0.0);
if or(jk~=N/2)|or(ik'-(1:N)'),
 disp('Cambifunb test 1 failed');
end;

// Ambiguity function of a sine wave
sig=fmconst(N,0.2);
amb=Cambifunb(sig);
[a b]=mtlb_max(amb);
if or(b-odd(N/2)*ones(1,N-1)),
 disp('Cambifunb test 2 failed');
end;

// Energy 
sig=noisecg(N);
amb=Cambifunb(sig);
if abs(abs(amb(odd(N/2),N/2))-norm(sig)^2)>sqrt(%eps),
 disp('Cambifunb test 3 failed');
end;

// Link with the Wigner-Ville distribution
sig=fmlin(N);
amb=Cambifunb(sig);
amb=amb([(N+modulo(N,2))/2+1:N 1:(N+modulo(N,2))/2],:);
ambi=mtlb_ifft(amb).';
tdr=zeros(N,N); 		// Time-delay representation
tdr(1:N/2,:)=ambi(N/2:N-1,:);
tdr(N:-1:N/2+2,:)=ambi(N/2-1:-1:1,:);
wvd1=real(mtlb_fft(tdr));
wvd2=tfrwv(sig);
errors=max(abs(wvd1-wvd2));
if errors>sqrt(%eps),
 disp('Cambifunb test 4 failed');
end;
				     

N=111;

// Ambiguity function of a pulse
sig=sum(((1:N)'==40),'c'); 
amb=Cambifunb(sig);
[ik,jk]=find(amb~=0.0);
if or(jk~=(N+1)/2)|or(ik'-(1:N)'),
 v('Cambifunb test 5 failed');
end;

// Ambiguity function of a sine wave
sig=fmconst(N,0.2);
amb=Cambifunb(sig);
[a b]=mtlb_max(amb(:,2:N-1));
if or(b-((N+1)/2)*ones(1,N-2)),
 disp('Cambifunb test 6 failed');
end;

// Energy 
sig=noisecg(N);
amb=Cambifunb(sig);
if abs(abs(amb((N+1)/2,(N+1)/2))-norm(sig)^2)>10e-5,//sqrt(%eps),
 disp('Cambifunb test 7 failed');
end;

// Link with the Wigner-Ville distribution
sig=fmlin(N);
amb=Cambifunb(sig);
amb=amb([(N+1)/2:N 1:(N-1)/2],:);
ambi=mtlb_ifft(amb).';
tdr=zeros(N,N); 		// Time-delay representation
tdr(1:ceil((N+1)/2),:)      = ambi((N+1)/2:N,:);
tdr(N:-1:(N+1)/2+1,:) = ambi((N-1)/2:-1:1,:);
wvd1=real(mtlb_fft(tdr));
wvd2=tfrwv(sig,1:N,N);
errors=max(abs(wvd1-wvd2));
if errors>10e-5//sqrt(%eps),
 disp('Cambifunb test 8 failed');
end;
