mode(-1)
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
//function tfrrppat
//TFRRPPAT Unit test for the function TFRRPPAG.

//	O. Lemoine - April 1996. 


N=128;

// Reality of the TFR
sig=noisecg(N);
[tfr,rtfr]=tfrrppag(sig);
if sum(or(abs(imag(rtfr))>sqrt(%eps))),
 error('tfrrppag test 1 failed');
end


// Energy conservation
sig=fmlin(N);
[tfr,rtfr]=tfrrppag(sig);
Es=norm(sig)^2;
Etfr=sum(mtlb_mean(rtfr));
if abs(Es-Etfr)>sqrt(%eps),
 error('tfrrppag test 2 failed');
end


// time localization
t0=30; sig=((1:N)'==t0)+0;
[tfr,rtfr]=tfrrppag(sig);
[ik,jk]=find(abs(rtfr)>sqrt(%eps));
if or(jk~=t0)|or(ik'-(1:N)'),
 error('tfrrppag test 3 failed');
end;


// frequency localization
f0=30;
sig=fmconst(N+6,f0/N);
[tfr rtfr]=tfrrppag(sig,N/2+2,N,tftb_window(N+1,'rect'));
if or(find(rtfr>2*max(rtfr)/N)~=f0+1)|(abs(mtlb_mean(rtfr)-1.0)>sqrt(%eps)),
 error('tfrrppag test 4 failed');
end;


N=131;

// Reality of the TFR
sig=noisecg(N);
[tfr,rtfr]=tfrrppag(sig);
if sum(or(abs(imag(rtfr))>sqrt(%eps))),
 error('tfrrppag test 5 failed');
end


// Energy conservation
sig=fmlin(N);
[tfr,rtfr]=tfrrppag(sig);
Es=norm(sig)^2;
Etfr=sum(mtlb_mean(rtfr));
if abs(Es-Etfr)>sqrt(%eps),
 error('tfrrppag test 6 failed');
end


// time localization
t0=30; sig=((1:N)'==t0)+0;
[tfr,rtfr]=tfrrppag(sig);
[ik,jk]=find(abs(rtfr)>sqrt(%eps));
if or(jk~=t0)|or(ik'-(1:N)'),
 error('tfrrppag test 7 failed');
end;


// frequency localization
f0=30;
sig=fmconst(N+6,f0/N);
[tfr rtfr]=tfrrppag(sig,round(N/2)+2,N,tftb_window(N,'rect'));
if and(find(rtfr>2*mtlb_max(rtfr)/N)~=f0+1)|(abs(mtlb_mean(rtfr)-1.0)>sqrt(%eps)),
 error('tfrrppag test 8 failed');
end;

